/**
 * Copyright (c) 2008 Washington University
 */
package org.nrg.xnat.filestore;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.nrg.xnat.tags.TagLabel;
import org.nrg.xnat.tags.TagLabelException;
import org.nrg.xnat.tags.UndefinedTagLabelException;

public interface MetadataOp {
    public void apply(int resourceID) throws SQLException;
    
    abstract class Util implements MetadataOp {
	private Util() {}	// this is just a home for utilities; don't permit subclassing
	private static final String SQL_GET_LABEL_ID = "SELECT tag_label_id FROM tag_labels WHERE tag_label_lc = LOWER(?)";

	protected final static int getLabelID(final Connection c, final TagLabel label) throws SQLException,TagLabelException {
	    final PreparedStatement getLabelID = c.prepareStatement(SQL_GET_LABEL_ID);
	    try {
		getLabelID.setString(1, label.toString());
		final ResultSet rs = getLabelID.executeQuery();
		try {
		    if (rs.next()) {
			return rs.getInt(1);
		    } else {
			throw new UndefinedTagLabelException(label);
		    }
		} finally {
		    try { rs.close(); } catch (SQLException ignore) {}
		}
	    } finally {
		try { getLabelID.close(); } catch (SQLException ignore) {}
	    }

	}
	
	
	protected final static int getLabelID(final Connection c, final String label)
	throws SQLException,TagLabelException {
	    return getLabelID(c, new TagLabel(label));
	}
    }
}